// ve6100.cpp: modulo per la gestione della tabella elaborazioni differite.

#include <tabapp.h>
#include "batbeld.h"

class TGestione_ELD : public Tab_application
{
protected:  // TRelation_application
  virtual bool user_create() ;                         
  virtual bool protected_record(TRectype& rec) ;
  virtual void init_insert_mode(TMask& m) ;
  virtual void init_modify_mode(TMask& m);
  virtual int rewrite(const TMask& m);
  virtual void init_query_mode (TMask& m);

public:
  TGestione_ELD() {}
  virtual ~TGestione_ELD() {}
};

inline bool TGestione_ELD::user_create()
{ return Tab_application::user_create(); }

inline bool TGestione_ELD::protected_record(TRectype& rec)
{ return Tab_application::protected_record(rec); }

inline void TGestione_ELD::init_insert_mode(TMask& m)
{
  Tab_application::init_insert_mode(m);
  m.disable (F_AVVIA);                            // disabilita il button quando il record non e' ancora stato registrato
  return;
}

inline int TGestione_ELD::rewrite(const TMask& m)
{ return Tab_application::rewrite (m); }

void TGestione_ELD::init_modify_mode(TMask& m)
{
  Tab_application::init_modify_mode(m);
  m.enable (F_AVVIA);                   // abilita la pressione del tasto solo quando il record e' stato registrato
  TString temp = m.get(F_CODICE);
  if (temp == "01")
    m.enable(F_PROGRAMMA, FALSE);
}

void TGestione_ELD::init_query_mode (TMask& m)
{
  Tab_application::init_query_mode(m);
  m.enable (F_AVVIA, FALSE);                    // disabilita il button anche in modalita' ricerca
  return;
}

int ve6100 (int argc, char **argv)
{
  TGestione_ELD a;
  a.run (argc, argv, "Gestione elaborazioni differite");
  return TRUE;
}
